#include <p18f4520.h>
#include "thread_list.h"

int tempor;
int pretendpriority = 2;
int temp2;
struct {
char stackpointer:5;
char TOSU[10];
char TOSH[10];
char TOSL[10];
char storeTOSL;
char storeTOSH;
char storeTOSU;
}scheduler_stack;

struct {
	char stackpointer:5;
	char spare2:3;
	char TOSU[10];
	char TOSH[10];
	char TOSL[10];
}temporary_stack;

struct {
char TOSU;
char TOSH;
char TOSL;
}temp_int_stack;

void empty(void){
tempor=200;
}

far rom char priority[32] = {0x00,0x08,0x10,0x18,0x20,
						 0x28,0x30,0x38,0x40,0x48,
						 0x50,0x58,0x60,0x68,0x70,
						 0x78,0x80,0x88,0x90,0x98,
						 0xA0,0xA8,0xB0,0xB8,0xC0,
						 0xC8,0xD0,0xD8,0xE0,0xE8,
						 0xF0,0xF8};
//unsigned int tempor;



void schedule(void){
tempor = TMR1L; //readTMR1L to ensure that the high values are placed onto TMR1H
tempor = TMR1H;
//temp2 = logic_thread.priority_timer;
if((TMR1H - logic_thread.priority_timer)>=priority[logic_thread.priority]){
store_main_stack();
logic_thread.thread();
logic_thread.update_from_temp();
};
//tempor = 20;
}//end of schedule

void store_main_stack(void){
scheduler_stack.storeTOSL = TOSL;	//store the current return point seperately
scheduler_stack.storeTOSH = TOSH;	//	""
scheduler_stack.storeTOSU = TOSU;	//	""
scheduler_stack.stackpointer = 2;	//store the current stack pointer
scheduler_stack.TOSL[2] = TOSL +0x0E;	//store return address first from this function
scheduler_stack.TOSH[2] = TOSH;	//because we need to add +0x02 on this one alone
scheduler_stack.TOSU[2] = TOSU;	//to skip over the following thread call
_asm pop _endasm; //remove the top of the stack
scheduler_stack.TOSL[1] = TOSL ;	//store return address first from this function
scheduler_stack.TOSH[1] = TOSH;	//because we need to add +0x02 on this one alone
scheduler_stack.TOSU[1] = TOSU;	//to skip over the following thread call
_asm pop _endasm; //remove the top of the stack
while(STKPTR & 0b11111){						//for each stack pointer
//scheduler_stack.TOSL[STKPTR & 0b11111] = TOSL;	//store return address
//scheduler_stack.TOSH[STKPTR & 0b11111] = TOSH;	//must build in + 0x02 on the first
//scheduler_stack.TOSU[STKPTR & 0b11111] = TOSU;	//address to return after the thread call
_asm pop _endasm; //remove the top of the stack
}
_asm PUSH _endasm;	//start a new stack level
WREG = scheduler_stack.storeTOSL;	//put the return from this function back in
TOSL = WREG;						//so it returns back to the place this function
WREG = scheduler_stack.storeTOSH;	//opened from
TOSH = WREG;
WREG = scheduler_stack.storeTOSU;
TOSU = WREG;
return;
}//end of store_main_stack

void retrieve_main_stack(void){

//POP ALL LEVELS????
while(STKPTR>0){
_asm POP _endasm;
}

while(STKPTR<=scheduler_stack.stackpointer){	//while the saved stack pointer is greater than the actual stack pointer
WREG = scheduler_stack.TOSL[STKPTR & 0b11111];	//load stored address into stack
TOSL = WREG;
WREG = scheduler_stack.TOSH[STKPTR & 0b11111];
TOSH = WREG;
WREG = scheduler_stack.TOSU[STKPTR & 0b11111];
TOSU = WREG;
_asm PUSH _endasm	//add another stack level
}
_asm POP _endasm	//remove last stack level

return;	//return back to the point of store stack was called (+0x02 to skip over the thread that has just run)

}


void store_temporary_stack(void){
temp_int_stack.TOSL = TOSL;	//store the current return point seperately
temp_int_stack.TOSH = TOSH;	//	""
temp_int_stack.TOSU = TOSU;	//	""
_asm POP _endasm; //pop it off the stack

temporary_stack.stackpointer = STKPTR;
while(STKPTR & 0b11111){						//for each stack pointer
temporary_stack.TOSL[STKPTR & 0b11111] = TOSL;	//store return address
temporary_stack.TOSH[STKPTR & 0b11111] = TOSH;	//must build in + 0x02 on the first
temporary_stack.TOSU[STKPTR & 0b11111] = TOSU;	//address to return after the thread call
_asm pop _endasm; //remove the top of the stack
}
_asm PUSH _endasm;	//start a new stack level
WREG = temp_int_stack.TOSL;	//put the return from this function back in
TOSL = WREG;						//so it returns back to the place this function
WREG = temp_int_stack.TOSH;	//opened from
TOSH = WREG;
WREG = temp_int_stack.TOSU;
TOSU = WREG;
}