#include <p18f4520.h>
#include "thread_list.h"

#pragma config WDT = OFF






void main(){
	T0CON = 0b11001000;
	//		  1-------	Timer0 on
	//		  -1------	8 bit mode
	//		  --0-----	Internal instruction clock source
	//		  ---0----	Source Edge Select. Unused here
	//		  ----1---	Timer Prescaler off
	//		  -----000	Prescaler Value Select Bits. Unused

	INTCON2=0b10001000;
	//	      1-------	pullups disabled
	//        -0------	int on falling edge
	//		  --0-----	TMR0 on internal clock
	//		  ---0----	inc on low to high trans
	//		  ----1---	prescaler on wdt
	//		  -----000	div by 2
	
	
	INTCONbits.T0IF = 0;	//Reset interrupt flag
	INTCONbits.T0IE = 0;	//Disable Timer0 Interrupt
	INTCONbits.GIE = 0;		//Disable Global Interrupts


	T1CON = 0b11111001;
	//		  1------- Read as 2 lots of 8 bytes
	//		  -1------ Clock is derived from internal timer1 oscillator
	//		  --00---- 1:1 prescaling
	//		  ----1--- Timer1 oscillator enabled
	//		  -----0-- Dont synchronize with external clock
	//		  ------0- Timer1 clock source internal clock
	//		  -------1 Enable Timer1
TMR1H = 0x00;
TMR1L = 0x00;
TMR1H = 0x00;
PIE1bits.TMR1IE = 0;
setup_logic_thread();
while(1){
schedule();
}
}


////////////////////////INTERRUPT SERVER///////////////////
void isr(void){    //interrupt server.Code executes on interrupt

	if (INTCONbits.T0IF){  //execute code when timer0 overflows
		INTCONbits.T0IF = 0; //reset timer0 overflow flag
		INTCONbits.T0IE = 0;	//Disable Timer0 Interrupt
		INTCONbits.GIE = 0;		//Disable Global Interrupts
		T0CON = 0b11001000;	//re - initialse timer0 to fix bug
		store_temporary_stack();
		retrieve_main_stack();
		return;
		}//end of timer0 overflow flag
}//end of interrupt server

#pragma code high_vector=0x08
void interrupt_at_high_vector(void){
_asm GOTO isr _endasm
}
#pragma code
#pragma interrupt isr
/////////////////////END OF INTERRUPT SERVER///////////////////
